import { continueWith } from '@most/core';
import { currentTime } from '@most/scheduler';
import { disposeWith } from '@most/disposable';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var nextAnimationFrame = function nextAnimationFrame(afp) {
  return new AnimationFrame(afp);
};

var animationFrames = function animationFrames(afp) {
  return continueWith(function () {
    return animationFrames(afp);
  }, nextAnimationFrame(afp));
};

var AnimationFrame = function () {
  function AnimationFrame(afp) {
    classCallCheck(this, AnimationFrame);

    this.afp = afp;
  }

  createClass(AnimationFrame, [{
    key: 'run',
    value: function run(sink, scheduler$$1) {
      var _this = this;

      var propagate = function propagate(timestamp) {
        return eventThenEnd(currentTime(scheduler$$1), timestamp, sink);
      };
      var request = this.afp.requestAnimationFrame(propagate);
      return disposeWith(function (request) {
        return _this.afp.cancelAnimationFrame(request);
      }, request);
    }
  }]);
  return AnimationFrame;
}();

var eventThenEnd = function eventThenEnd(t, x, sink) {
  sink.event(t, x);
  sink.end(t);
};

export { nextAnimationFrame, animationFrames };
//# sourceMappingURL=index.es.js.map
