(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@most/core'), require('@most/scheduler'), require('@most/disposable')) :
	typeof define === 'function' && define.amd ? define(['exports', '@most/core', '@most/scheduler', '@most/disposable'], factory) :
	(factory((global.mostXHR = {}),global.mostCore,global.mostScheduler,global.mostDisposable));
}(this, (function (exports,core,scheduler,disposable) { 'use strict';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var nextAnimationFrame = function nextAnimationFrame(afp) {
  return new AnimationFrame(afp);
};

var animationFrames = function animationFrames(afp) {
  return core.continueWith(function () {
    return animationFrames(afp);
  }, nextAnimationFrame(afp));
};

var AnimationFrame = function () {
  function AnimationFrame(afp) {
    classCallCheck(this, AnimationFrame);

    this.afp = afp;
  }

  createClass(AnimationFrame, [{
    key: 'run',
    value: function run(sink, scheduler$$1) {
      var _this = this;

      var propagate = function propagate(timestamp) {
        return eventThenEnd(scheduler.currentTime(scheduler$$1), timestamp, sink);
      };
      var request = this.afp.requestAnimationFrame(propagate);
      return disposable.disposeWith(function (request) {
        return _this.afp.cancelAnimationFrame(request);
      }, request);
    }
  }]);
  return AnimationFrame;
}();

var eventThenEnd = function eventThenEnd(t, x, sink) {
  sink.event(t, x);
  sink.end(t);
};

exports.nextAnimationFrame = nextAnimationFrame;
exports.animationFrames = animationFrames;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.js.map
